﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SciChart.Data.Model;

namespace ulongAxisValues
{

    public class ULongRange : Range<ulong>
    {
        public ULongRange() : this(ulong.MaxValue, ulong.MaxValue)
        {
        }

        public ULongRange(ulong min, ulong max)
        {
            Min = min;
            Max = max;
        }
        public override object Clone()
        {
            return new ULongRange(Min, Max);
        }

        public override DoubleRange AsDoubleRange()
        {
            throw new NotImplementedException();
        }

        public override IRange<ulong> SetMinMax(double min, double max)
        {
            throw new NotImplementedException();
        }

        public override ulong Diff => Max - Min;
        public override bool IsZero => Diff == 0;

        public override IRange<ulong> SetMinMax(double min, double max, IRange<ulong> maxRange)
        {
            throw new NotImplementedException();
        }

        public override IRange<ulong> GrowBy(double minFraction, double maxFraction)
        {
            return new ULongRange(Min - (ulong)Math.Round(minFraction * Min), Max + (ulong)Math.Round(maxFraction * Max));
        }

        public override IRange<ulong> ClipTo(IRange<ulong> maximumRange)
        {
            return new ULongRange(
                Min < maximumRange.Min ? maximumRange.Min : Min,
                Max > maximumRange.Max ? maximumRange.Max : Max);
        }
    }
}
